# ADML actions

## send_xml_to_entity

Sends a diameter message in xml format (see DTDs/message.dtd) as client to the server(s) configured.

Arguments: xml[, answers_to]
* xml: the diameter message in xml format.
* answers_to: optional step number of a 'wait_xml_from_entity' for a request message.
              Steps are the actions numbered from 1 to N
Example(1):
```
- action: AF/send_xml_to_entity
    xml: aar-initial.xml
```

Example(2):
```
- action: AF/wait_xml_from_entity
  arguments:
    xml: dpr.xml

- action: AF/send_xml_to_entity
  arguments:
    xml: dpa.xml
    answers_to: 1
```

## wait_xml_from_entity

Waits a diameter message in xml format (see DTDs/message.dtd) as client from the server(s) connected.
Step blocks until match reception (regular expressions could be used).

Arguments: xml
* xml: the diameter message in xml format.

Example:
```
- action: AFPC/wait_xml_from_entity
  arguments:
    xml: aaa.xml
```

## send_xml_to_client

Sends a diameter message in xml format (see DTDs/message.dtd) as server to any client(s) connected.

Arguments: xml[, answers_to]
* xml: the diameter message in xml format.
* answers_to: optional step number of a 'wait_xml_from_client' for a request message.
              Steps are the actions numbered from 1 to N
Example(1):
```
- action: AF/send_xml_to_client
  arguments:
    xml: dpr.xml
```

Example(2):
```
- action: AFPC/wait_xml_from_client
    xml: dpr.xml
  arguments:

- action: AFPC/send_xml_to_client
    xml: dpa.xml
  arguments:
```

## wait_xml_from_client

Waits a diameter message in xml format (see DTDs/message.dtd) as server from the client(s) connected.
Step blocks until match reception (regular expressions could be used).

Arguments: xml
* xml: the diameter message in xml format.

Example:
```
- action: AFPC/wait_xml_from_client
  arguments:
    xml: dpr.xml
```

