// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_Allocator_hpp
#define anna_core_Allocator_hpp

namespace anna {

/**
   \param T Clase asociada a este ubicador. Debe tener un constructor vacio.

   @see Recycler
*/
template <typename T> class Allocator {
public:
  /**
     Creacion de una instancia de tipo T.
     \return Una nueva instancia del tipo T.
  */
  static T* create() throw() { return new T; }

  /**
     Libera los recursos asociados a la instancia recibida como parametro.
     \param t Instancia que vamos a liberar.
  */
  static void destroy(T* t) throw() { delete t; }
};

}

#endif
