// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_oam_defines_hpp
#define anna_core_oam_defines_hpp


namespace anna {

namespace oam {


/**
   Counter data container
*/
typedef struct {
  /** Counter id over scope (0-999) */
  int Offset;
  /** Counter description (same for all cloned scopes...) */
  std::string Description;
} counter_data_t;

/**
   Alarm data container
*/
typedef struct {
  /** External text identification */
  int ExternalId;
  /** Comma-separated list of dynamic variable names (same order than launched with #activateAlarm and #cancelAlarm) */
  std::string DynamicVariablesCSL;
  /** Alarm activation identifier */
  int ActivationId;
  /** Alarm cancellation identifier. If missing, the alarm will interpreted as non-transferable */
  int CancellationId;
  /** Alarm description added within the module. If empty string is provided, default description for non-registered will be searched (#getDefaultInternalAlarmDescription) */
  std::string Description;
} alarm_data_t;


}
}

#endif

