// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_comm_ServerSocket_hpp
#define anna_diameter_comm_ServerSocket_hpp


#include <anna/comm/ServerSocket.hpp>
#include <anna/core/RuntimeException.hpp>

// STL
#include <string>

#include <anna/config/defines.hpp>


namespace anna {
namespace xml {
class Node;
}
namespace comm {
class INetAddress;
class ClientSocket;
}
}

namespace anna {

namespace diameter {

namespace comm {


class LocalServer;

/**
   Diameter server socket
*/
class ServerSocket : public anna::comm::ServerSocket {

  LocalServer * a_localServer;

  virtual bool eventAcceptConnection(const anna::comm::ClientSocket &clientSocket) throw(anna::RuntimeException);


public:

  /**
     Constructor

     @param localAddress Listen address
     @param localServer Local access point
     @param engine Diameter comm engine
  */
  ServerSocket(const anna::comm::INetAddress &localAddress, LocalServer *localServer);


  /** Destructor */
  // ~ServerSocket() { detach(); } // detaching avoids bad file descriptor at poll when application destroy diameter ServerSockets


  //friend class LocalServer;
};

}
}
}

#endif

