// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_test_Control_hpp
#define anna_test_Control_hpp

#include <anna/core/mt/Mutex.hpp>
#include <anna/core/util/Average.hpp>
#include <anna/core/util/Millisecond.hpp>
#include <anna/core/util/Microsecond.hpp>

namespace anna {
   namespace xml {
      class Node;
   }
   namespace comm {
      class Communicator;
      namespace socket {
         class Client;
      }
   }
}

namespace test {

using namespace anna;

class Control : public Mutex {
public:
   Control (comm::Communicator* engine);

   void setDelay (const Millisecond delay) throw () { a_delay = delay; }
   void setMaxMessage (const int maxMessage) throw () { a_maxMessage = maxMessage; }

   int getMaxMessage () const throw () { return a_maxMessage; }

   bool canContinue (const comm::socket::Client& clientSocket) throw (RuntimeException);
   void delay () throw (RuntimeException);
   Millisecond latency (const Millisecond& init) throw (RuntimeException);

   void report () throw ();
   void stop () throw (RuntimeException);

   xml::Node* asXML (xml::Node* parent) throw ();

private:
   comm::Communicator& a_engine;
   Millisecond a_delay;
   Millisecond a_initTime;
   int a_maxMessage;
   Average <Microsecond> a_avgDelay;
   Average <Millisecond> a_avgLatency;
};

}

#endif
