// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_xml_Decompressor_hpp
#define anna_xml_Decompressor_hpp

#include <anna/core/util/ZBlock.hpp>

namespace anna {

class DataBlock;

namespace xml {

class Document;

/**
   Obtiene la informacin original de un documento XML comprimido con una instancia de la clase Compressor.

   \see Compressor

   \warning Esta es una clase bastante pesada, por lo que casi-imprescindible reusar una misma instancia cada vez
   que se requiera comprimir un documento XML.
*/
class Decompressor : ZBlock {
public:
  /**
   * Constructor.
   */
  Decompressor();

  /**
   * Destructor.
   */
  virtual ~Decompressor();

  /**
   * Recupera el contenido original del documento XML comprimido con la clase Compressor.
   * \param dataBlock Bloque de datos obtenido como resultado de invocar a Compressor::apply.
   * \return El documento XML comprimido en el bloque de datos.
   */
  const Document& apply(const DataBlock& dataBlock) throw(RuntimeException);

private:
  Document* a_document;

  Decompressor(const Decompressor&);
};

}
}

#endif

