// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/diameter.comm/ServerSocket.hpp>
#include <anna/diameter.comm/LocalServer.hpp>
#include <anna/diameter.comm/Transport.hpp>
#include <anna/core/functions.hpp>

#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/comm/ClientSocket.hpp>
#include <anna/core/functions.hpp>

// STL
#include <string>


#include <iostream>


using namespace anna::diameter::comm;

ServerSocket::ServerSocket(const anna::comm::INetAddress &localAddress, LocalServer *localServer) :
  anna::comm::ServerSocket(localAddress, true /* shared bind */, &anna::diameter::comm::Transport::getFactory()),
  a_localServer(localServer) {;}


bool ServerSocket::eventAcceptConnection(const anna::comm::ClientSocket &clientSocket) throw(anna::RuntimeException) {
  LOGMETHOD(anna::TraceMethod tttm("anna::diameter::comm::ServerSocket", "eventAcceptConnection", ANNA_FILE_LOCATION));
  a_localServer->createServerSession(clientSocket);
//   // Aprovecho para hacer el purgado de idle() + deprecated, y as me evito un temporizador de purgado:
//   a_localServer->eraseDeprecatedIdleServerSessions();
  // Always accept: we control by mean closing/listening on server socket
  return true;
}


