// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <ctype.h>

#include <anna/http/functions.hpp>
#include <anna/http/internal/sccs.hpp>

using namespace anna;

void http::functions::initialize()
throw() {
  http::sccs::activate();
}

int http::functions::find(const void* _data, const int size, const char* searched)
throw() {
  int result(-1);
  const char* data = (const char*) _data;
  int i, matchBegin, matchLen;
  i = matchLen = 0;
  matchBegin = -1;

  while((i + matchLen) < size) {
    if(tolower(data [i + matchLen]) == tolower(searched [matchLen])) {
      if(matchBegin == -1)
        matchBegin = i;

      if(searched [++ matchLen] == 0) {
        result = matchBegin;
        break;
      }
    } else {
      if(matchBegin == -1)
        i ++;
      else {
        i = matchBegin + 1;
        matchBegin = -1;
        matchLen = 0;
      }
    }
  }

  return result;
}
