// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <stdio.h>

#include <anna/config/defines.hpp>

#include <anna/io/TextReader.hpp>
#include <anna/io/internal/sccs.hpp>

using namespace std;
using namespace anna;

io::TextReader::TextReader(const int maxLength) :
  AbstractReader(),
  a_maxLength(maxLength) {
  a_buffer = new char [maxLength];
  sccs::activate();
}

io::TextReader::TextReader(const char* filename, const int maxLength) :
  AbstractReader(filename),
  a_maxLength(maxLength) {
  a_buffer = new char [maxLength];
  sccs::activate();
}

io::TextReader::TextReader(const std::string& filename, const int maxLength) :
  AbstractReader(filename),
  a_maxLength(maxLength) {
  a_buffer = new char [maxLength];
  sccs::activate();
}

/* virtual */
io::TextReader::~TextReader() {
  delete [] a_buffer;
}

const char* io::TextReader::fetch()
throw(RuntimeException) {
  verify();
  char* result = fgets(a_buffer, a_maxLength - 1, a_file);

  if(result != NULL) {
    char* w = anna_strchr(result, '\n');

    if(w != NULL)
      *w = 0;
  }

  return result;
}
