// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/mt/Guard.hpp>

#include <anna/ldap/internal/Timer.hpp>
#include <anna/ldap/Response.hpp>
#include <anna/ldap/Session.hpp>

using namespace std;
using namespace anna;

void ldap::Timer::expire(timex::Engine*)
throw(RuntimeException) {
  Response* response = getResponse();
  Session* session = response->getSession();
  Guard guard(session, "anna::ldap::Timer::expire");
  LOGDEBUG(
    string msg("anna::ldap::Timer::expire | ");
    msg += response->asString();
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );
  session->expireResponse(response);
}

string ldap::Timer::asString() const
throw() {
  const Response* response = getResponse();
  string result("anna::ldap::Timer { ");
  result += timex::Transaction::asString();

  if(response != NULL) {
    result += " | ";
    result += response->asString();
  } else
    result += " | Response: <null>";

  return result += " }";
}
